#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <stdarg.h>
#include <stdio.h>
#include <errno.h>
#include <string.h>
#include "log.h"
#include "callbacks.h"

#define MAXLINE 1024

static char *dial_errorbuf;

int dial_log_init(void)
{
      	if (!(dial_errorbuf = malloc(MAXLINE+1))) {
		dial_log("malloc failed");
      		return -1;
	}
	return 0;
}

void dial_log(const char *format, ...)
{
	va_list ap;

	va_start(ap, format);
	vsnprintf(dial_errorbuf, MAXLINE, format, ap);
	va_end(ap);

	dial_log_raw(dial_errorbuf);
}

void dial_log_err(const char *format, ...)
{
	va_list ap;
	int ret;

	va_start(ap, format);
	/* FIXME: vsnprintf/snprintf is not portable. At least GNU (Linux) and 
	 * *BSD have it though
	 */
	ret = vsnprintf(dial_errorbuf, MAXLINE, format, ap);
	snprintf(dial_errorbuf+ret, MAXLINE-ret, ": %s\n", strerror(errno));
	va_end(ap);

	dial_log_raw(dial_errorbuf);
}
