#ifdef HAVE_CONFIG_H
#  include <config.h>
#endif

#include <stdlib.h>
#include <signal.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <string.h>
#include <gtk/gtk.h>
#include "log.h"
#include "rcfile.h"
#include "callbacks.h"
#include "interface.h"
#include "socket.h"
#include "main.h"

int main(int argc, char *argv[])
{
	gtk_set_locale();
	gtk_init(&argc, &argv);

#if 0
	add_pixmap_directory (PACKAGE_DATA_DIR "/pixmaps");
	add_pixmap_directory (PACKAGE_SOURCE_DIR "/pixmaps");
#endif
	main_window = create_main_window();
	config_window = create_config_window();
	log_window = create_log_window();

	init_status();
	if (dial_log_init()) {
		/* TODO: error window */
		return EXIT_FAILURE;
	}
	dial_status("Disconnected");
	if (dial_rcfile_setname()) {
		/* TODO: error window */
		return EXIT_FAILURE;
	}
	if (dial_rcfile_read())
		dial_log("error reading rcfile\n"); /* non-fatal */
	if (dial_sock_sigsetup()) {
		dial_log("error setting signals\n");
		/* TODO: error window */
		return EXIT_FAILURE;
	}

	gtk_widget_show(main_window);
	gtk_main();
	return EXIT_SUCCESS;
}
